#region Copyright
/*
 * Copyright 2005 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Collections;

namespace Seasar.Framework.Aop.Interceptors
{
	/// <summary>
	/// Intercept̑ΏۂƂȂ郁\bhƃCX^XMockɂ܂
	/// </summary>
	public class MockInterceptor : AbstractInterceptor
	{

		/// <summary>
		/// Mock̖߂l
		/// </summary>
		private Hashtable returnValues_ = new Hashtable();

		/// <summary>
		/// Mock̗O
		/// </summary>
		private Hashtable exceptions_ = new Hashtable();

		/// <summary>
		/// \bhĂяoς݂ǂtO
		/// </summary>
		private Hashtable invokedMethods_ = new Hashtable();

		/// <summary>
		/// \bhĂяoƂ̈
		/// </summary>
		private Hashtable invokedMethodArgs_ = new Hashtable();
		
		/// <summary>
		/// RXgN^
		/// </summary>
		public MockInterceptor() 
        {
		}
		
        #region IMethodInterceptor NX

        /// <summary>
        /// \bhInterceptꍇÃ\bhĂяo܂
        /// </summary>
        /// <param name="invocation">IMethodInvocation</param>
        /// <returns>Intercept郁\bh̖߂l</returns>
        public override object Invoke(IMethodInvocation invocation)
        {
            string methodName = invocation.Method.Name;
            invokedMethods_[methodName] = true;
            invokedMethodArgs_[methodName] = invocation.Arguments;

            if (exceptions_.ContainsKey(methodName)) 
            {
                throw exceptions_[methodName] as Exception;
            } 
            else if (exceptions_.ContainsKey("")) 
            {
                throw exceptions_[""] as Exception;
            } 
            else if (returnValues_.ContainsKey(methodName)) 
            {
                return returnValues_[methodName];
            } 
            else 
            {
                return returnValues_[""];
            }
        }

        #endregion

        /// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="value">Mock̖߂l</param>
		public MockInterceptor(object value) 
        {
			SetReturnValue(value);
		}

        /// <summary>
        /// ߂l̐ݒ
        /// </summary>
        /// <remarks>
        /// Mockׂ̂Ẵ\bh̖߂lݒ肵܂B
        /// </remarks>
        /// <param name="returnValue">߂l</param>
		public void SetReturnValue(object returnValue) {
			SetReturnValue("", returnValue);
		}

        /// <summary>
        /// ߂l̐ݒ
        /// </summary>
        /// <remarks>
        /// Mock̎w肳ꂽÕ\bh̖߂lݒ肵܂B
        /// </remarks>
        /// <param name="methodName">߂lݒ肷郁\bh</param>
        /// <param name="returnValue">߂l</param>
		public void SetReturnValue(String methodName, object returnValue) 
        {
			returnValues_[methodName] = returnValue;
		}

        /// <summary>
        /// O̐ݒ
        /// </summary>
        /// <remarks>
        /// Mockׂ̂Ẵ\bhɗOݒ肵܂B
        /// </remarks>
        /// <param name="exception">O</param>
		public void SetThrowable(Exception exception) 
        {
			SetThrowable("", exception);
		}
		
        /// <summary>
        /// O̐ݒ
        /// </summary>
        /// <remarks>
        /// Mockׂ̂Ẵ\bhɗOݒ肵܂B
        /// </remarks>
        /// <param name="methodName">Oݒ肷郁\bh</param>
        /// <param name="exception">O</param>
        public void SetThrowable(String methodName, Exception exception) 
        {
			exceptions_[methodName] = exception;
		}

        /// <summary>
        /// Mock̃\bhɌĂяoĂ邩肵܂
        /// </summary>
        /// <param name="methodName">ĂяoĂ邩ǂ肷郁\bh</param>
        /// <returns>Mock̃\bhɌĂяoĂ邩</returns>
		public bool IsInvoked(String methodName) {
			return invokedMethods_.ContainsKey(methodName);
		}

        /// <summary>
        /// Mock̃\bhĂ΂ꂽƂ̈擾܂
        /// </summary>
        /// <param name="methodName">擾郁\bh</param>
        /// <returns>̃Xg</returns>
		public object[] GetArgs(String methodName) {
			return (object[]) invokedMethodArgs_[methodName];
		}

	}
}
